#include <demo.h>
#include <blur.h>

float sqrt_table[16384];
int glowSprite;
unsigned int tmpbuf[XSIZ*YSIZ];

#define SQRT(i) sqrt_table[(int)(i)]

void initRadialBlur(void)
{
  int i;
  for(i=0;i<16384;i++)
    sqrt_table[i] = sqrt(i);

  glowSprite = loadPng("data/particle.png");


}


void radialBlur( unsigned int *tex, int cx, int cy, int intensity )
{
  int x,y;
  float vx,vy;
  float px,py; 
  int p1,p2;
  int r,g,b;
  float length;
  int offset1, offset2;
  int offsety=cy*XSIZ;
  
  for ( y=cy; y!=0; y-- )
    {
      for ( x=cy; x!=0; x-- )
	{ 
	  vx = (float)(cx - x);
	  vy = (float)(cy - y);

	  length = SQRT( vx*vx + vy*vy );
	  vx /= length;
	  vy /= length;
      

	  vx *= intensity;
	  vy *= intensity;

	  px = (int)vx + (int)x;
	  py = (int)vy + (int)y;

	  offset1 = (int)( x+ y * XSIZ);
	  offset2 = (int)(px+py * XSIZ);

	  p1 = tex[offset1]&0x0000FF;
	  p2 = tex[offset2]&0x0000FF;
	  b = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF00)>>8;
	  p2 = (tex[offset2]&0x00FF00)>>8;
	  g = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF0000)>>16;
	  p2 = (tex[offset2]&0x00FF0000)>>16;
	  r = (p1 + p2) / 2;
	  tex[ x + offsety] = (r<<16)+(g<<8)+b;
	}
      offsety-=XSIZ;
    }

  offsety=cy*XSIZ;
  for ( y=cy; y!=YSIZ; y++ )
    {
      for ( x=cy; x!=0; x-- )
	{ 
	  vx = (float)(cx - x);
	  vy = (float)(cy - y);

	  length = SQRT( vx*vx + vy*vy );
      
	  vx /= length;
	  vy /= length;
      

	  vx *= intensity;
	  vy *= intensity;

	  px = (int)vx + (int)x;
	  py = (int)vy + (int)y;

	  offset1 = (int)( x+ y * XSIZ);
	  offset2 = (int)(px+py * XSIZ);

	  p1 = tex[offset1]&0x0000FF;
	  p2 = tex[offset2]&0x0000FF;
	  b = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF00)>>8;
	  p2 = (tex[offset2]&0x00FF00)>>8;
	  g = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF0000)>>16;
	  p2 = (tex[offset2]&0x00FF0000)>>16;
	  r = (p1 + p2) / 2;

	  tex[ x +offsety] = (r<<16)+(g<<8)+b;
	}
      offsety+=XSIZ;
    }

  offsety=cy*XSIZ;
  for ( y=cy; y!=YSIZ; y++ )
    {
      for ( x=cy; x!=XSIZ; x++ )
	{ 
	  vx = (float)(cx - x);
	  vy = (float)(cy - y);

	  length = SQRT( vx*vx + vy*vy );
      
	  vx /= length;
	  vy /= length;
      

	  vx *= intensity;
	  vy *= intensity;

	  px = (int)vx + (int)x;
	  py = (int)vy + (int)y;

	  offset1 = (int)( x+ y * XSIZ);
	  offset2 = (int)(px+py * XSIZ);

	  p1 = tex[offset1]&0x0000FF;
	  p2 = tex[offset2]&0x0000FF;
	  b = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF00)>>8;
	  p2 = (tex[offset2]&0x00FF00)>>8;
	  g = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF0000)>>16;
	  p2 = (tex[offset2]&0x00FF0000)>>16;
	  r = (p1 + p2) / 2;

	  tex[ x + offsety] = (r<<16)+(g<<8)+b;
	}
      offsety+=XSIZ;
    }
  offsety=cy*XSIZ;
  for ( y=cy; y!=0; y-- )
    {
      for ( x=cy; x!=XSIZ; x++ )
	{ 
	  vx = (float)(cx - x);
	  vy = (float)(cy - y);

	  length = SQRT( vx*vx + vy*vy );
      
	  vx /= length;
	  vy /= length;
      
	  vx *= intensity;
	  vy *= intensity;

	  px = (int)vx + (int)x;
	  py = (int)vy + (int)y;

	  offset1 = (int)( x+ y * XSIZ);
	  offset2 = (int)(px+py * XSIZ);

	  p1 = tex[offset1]&0x0000FF;
	  p2 = tex[offset2]&0x0000FF;
	  b = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF00)>>8;
	  p2 = (tex[offset2]&0x00FF00)>>8;
	  g = (p1 + p2) / 2;

	  p1 = (tex[offset1]&0x00FF0000)>>16;
	  p2 = (tex[offset2]&0x00FF0000)>>16;
	  r = (p1 + p2) / 2;

	  tex[ x + offsety] = (r<<16)+(g<<8)+b;
	}
      offsety-=XSIZ;
    }
}


void Noise(unsigned int *buffer, int n)
{
  int x,y;
  caca_set_color(CACA_COLOR_DARKGRAY, CACA_COLOR_BLACK);
  for(y=1;y<caca_get_height()-1;y++)
    for(x=1;x<caca_get_width()-1;x++)
      {
	if(caca_rand(0,n) == 0)      
	  caca_putchar(x,y, caca_rand(32,127));  	
	
    }

}


void Blur(unsigned char *buffer)
{
  int x,y;

    for(y=2;y<YSIZ-1;y++)
    {
      for(x=4;x<XSIZ*4;x++)
	{
	  buffer[x+y*(XSIZ*4)] = (buffer[x+1+y*(XSIZ*4)] +
	    buffer[x-1+y*(XSIZ*4)] +
	    buffer[x+(y+1)*(XSIZ*4)] +
	    buffer[x+y*(XSIZ*4)])/4.0f;

	  if(buffer[x+y*(XSIZ*4)])
	    buffer[x+y*(XSIZ*4)]-=3;
	  if(buffer[x+y*(XSIZ*4)]<3)
	    buffer[x+y*(XSIZ*4)]=0;

	}
    }
}



void Glow(unsigned int *buffer, int level, int size)
{
  int i;
  int x,y,o=0;
  
  memset(tmpbuf, 0, XSIZ*YSIZ*4);
  for(y=0;y<YSIZ;y+=size)
    {
      
    for(x=0;x<XSIZ;x+=size)
      {
	i=x+o;
	if((COLOR_R(buffer[i])>level) ||
	   (COLOR_G(buffer[i])>level) ||
	   (COLOR_B(buffer[i])>level))
	  {
	     putSquareAdditive(buffer, x,y, size, 
			      (COLOR_R(buffer[i])),
			      (COLOR_G(buffer[i])),
			      (COLOR_B(buffer[i])));
	    

	    

	    //putSpriteAdditive(tmpbuf,glowSprite , x,y, COLOR_R(buffer[i])/255.0f);	      
	  }
      }
    o+=(XSIZ)*size;
    }
}

#ifndef __USE_X86ASM__
void decayBlur(unsigned int *buffer, int value)
{

  int x,y;

  for(y=0;y<YSIZ;y+=2)
    {
      for(x=0;x<XSIZ;x++)
	{
	  if((x-value)>0)
	  buffer[x+y*XSIZ] = buffer[x-value+y*XSIZ];
	}
    }
  for(y=1;y<YSIZ;y+=2)
    {
      for(x=0;x<XSIZ;x++)
	{
	  if((x+value)<XSIZ)
	  buffer[x+y*XSIZ] = buffer[x+value+y*XSIZ];
	}
    }
}
#endif
