#include <demo.h>
#include <3d.h>
#include <raytracer.h>



int initMetaballs(int nbrBall)
{
  int o;
  o = addObject(nbrBall, 0);
  objectSetInvisible(o);
 
  return o;
}



void raytraceBalls(unsigned int *buffer, sObject *meta, int xsiz, int ysiz)
{
  int px,py;
  float pz;
  float x0, y0, z0;
  float y1;
  float dx,dy;;
  float distance;
  int i, count = meta->vertexCount;
  sMeta *metaball;
  float sx = XSIZ/xsiz,sy=YSIZ/ysiz;
  float cx, cy;
  float cr,cg,cb;
  metaball = malloc(sizeof(sMeta)*count);
  for(i=0;i<count;i++)
    {
      metaball[i].position.x = meta->tvertex[i].x;
      metaball[i].position.y = meta->tvertex[i].y;
      metaball[i].position.z = meta->tvertex[i].z;
      metaball[i].position.r = meta->vertex[i].r;

    }


  x0=0;  y0=0;  z0=0;
  

  for(py=1;py<ysiz;py++)
    {
      y1 = py/(ysiz*1.0f);
      dy = y1;

    

      for(i=0;i<count;i++)
	{
	  metaball[i].diffy = dy-metaball[i].position.y;
	  metaball[i].diffy2 = metaball[i].diffy*metaball[i].diffy;

	}

      for(px=1;px<xsiz-2;px++)
	{
	 dx = px/(xsiz*1.0f);


	  for(i=0;i<count;i++)
	    {
	      metaball[i].diffx = dx-metaball[i].position.x;
	      metaball[i].diffx2 = metaball[i].diffx*metaball[i].diffx;
	      metaball[i].dxy = metaball[i].diffx2  +  metaball[i].diffy2;
	    }



	 
	 

	  for(pz=0;pz<1.0f;pz+=0.199)
	    {  
	      distance = 0;
	      cr=cg=cb=0;
	      for(i=0;i<count;i++)
		{
		   metaball[i].diffz = pz-metaball[i].position.z;
		
		   distance+=(1.0f/
			      (metaball[i].dxy +(metaball[i].diffz*metaball[i].diffz))
			      /metaball[i].position.r);
		   
		   cr+=(meta->tvertex[i].color.r*distance)*255;
		   cg+=(meta->tvertex[i].color.g*distance)*255;;
		   cb+=(meta->tvertex[i].color.b*distance)*255;;

		   
		}
	    
	      if(distance/count>1.5)
		{
		  float l;
		  sVector a, *b;
		  sVector v;
		  /*

<stilDRUNK> if (distance > 6) {
<stilDRUNK> vecteur v = 0;
<stilDRUNK> pour chaque meta {
<stilDRUNK>   v += vecteur (centre_de_la_meta - point); // c'est ptet bien l'opposé je c pas
<stilDRUNK> }
<Jylam> stilDRUNK: ouai j'ai eu
<stilDRUNK> v /= nb_de_metas;
<stilDRUNK> normalizeVector(v);
<stilDRUNK> normalizeVector(a); // normalise ton vecteur de lumiere mais pas a chaque frame hein!!
<Jylam> en fait j'ai modif un peu
<stilDRUNK> l = sqrt((a.x*b.x)+(a.y*b.y)+(a.z*b.z));

		  */
	

		  a.x = 1.0;
		  a.y = 1.0;
		  a.z = 1.0;
		  
		  v.x = 0;
		  v.y = 0;
		  v.z = 0;
		  for(i=0;i<count;i++)
		    {
		      v.x += (metaball[i].position.x-dx);
		      v.y += (metaball[i].position.y-y1);
		      v.z += (metaball[i].position.z-pz);
		    }
		  v.x/=count;
		  v.y/=count;
		  v.z/=count;
		  

		  normalizeVector(&v);


		 
		  
		  b = cross(&a, &v);
		  l = sqrt((b->x*b->x)+(b->y*b->y)+(b->z*b->z));
		  
	

		  // l = sqrt((a.x*v.x)+(a.y*v.y)+(a.z*v.z));
		  
		 
		  if(l>1)
		    l=1;

		  cr/=count;
		  cg/=count*255;
		  cb/=count*255;
		  cr*=l*1.0f;
		  cg*=l*1.0f;
		  cb*=l*1.0f;
		  if(cb>255)
		    cb=255;
		  if(cg>255)
		    cg=255;
		  if(cr>255)
		    cr=255;


		  for(cy=0;cy<sy;cy++)
		    for(cx=0;cx<sx;cx++)
		      {
		

			buffer[(int)((cx+px*sx)+(int)(cy+py*sy)*XSIZ)] = 
			  
			  MAKE_COLOR_CHAR((((int)cr)&0xff),
					  (((int)cg)&0xff),
					  (((int)cb)&0xff));
			  


			//scene->zbuffer[(int)(px*sx)+(int)(py*sy)*(XSIZ)] = pz;
		      }
	      	  break;
		}
	    }
	}
      
    }
  free(metaball);
  
 
}


sVector *cross(sVector *a, sVector *b)
{
  sVector *c;
  c = malloc(sizeof(sVector));

  c->x = a->y * b->z - b->y * a->z;
  c->y = a->z * b->x - b->z * a->x;
  c->z = a->x * b->y - b->x * a->y;

  return c;

}
