#include <demo.h>
#include <sprites.h>

#include <3d.h>



void putSquare(unsigned int *s, int x, int y, int size, int r, int g, int b)
{
  int i,j;

  for(j=y;j<y+size;j++)
    for(i=x;i<x+size;i++)
      if(((i+j*XSIZ)>0) && ((i+j*XSIZ)<(XSIZ*YSIZ)))
	s[i+j*XSIZ] = MAKE_COLOR_CHAR(r,g,b);


}

void putSquareAdditive(unsigned int *s, int x, int y, int size, int r, int g, int b)
{
  int xe, ye;
  int i,j,jb=x*4,oi=y*XSIZ, oib=y*XSIZ*4;
  int tr, tg, tb;
  unsigned char *sb = (unsigned char*)s;

  if(x>XSIZ || y>YSIZ)
    return;
  xe = x+size;
  ye = y+size;
  if(xe>XSIZ)
    xe=XSIZ;
  if(ye>YSIZ)
    ye=YSIZ;

  for(i=y;i<ye;i++)
    {
      for(j=x;j<xe;j++)
	{
	  tr = sb[jb+oib] + r;
	  if(tr>255) tr=255;
	  tg = sb[jb+oib+1] + g;
	  if(tg>255) tg=255;
	  tb = sb[jb+oib+2] + b;
	  if(tb>255) tb=255;

	  s[j+oi] = MAKE_COLOR_CHAR(((unsigned char)tr),((unsigned char)tg),((unsigned char)tb));
	  

	  jb+=4;

	}
      oi+=XSIZ;
      oib+=(XSIZ*4);
    }
}


void putSpriteAdditive(int *buffer, sSprite *spritet, int px, int py, float life)
{
  int x,y;
  int offsetx=px, startx;
  int offsety, starty;
  int offset=0, offset2;
  unsigned int r,g,b;
  unsigned int r2,g2,b2;
  unsigned char c1,c2;


  if((px>XSIZ) || (py>YSIZ))
    return;
 

  startx = px;
  if(startx<0)
    startx = -px;
  starty = py;
  if(starty<0)
    starty = -py;


  for(y=0;y<spritet->height;y++)
    {
      offsety = y+py;
      if(offsety>YSIZ)
	return;
     
      offset2 = offsety*XSIZ;

      if(offsety>0)
	for(x=0;x<spritet->width;x++)
	  {

	    if(offsetx>=XSIZ)
	      break;
	    if(offsetx>0)
	      {
		c1 = spritet->pixels[offset];
		c2 = buffer[offsetx+offset2];

		r = life*((c1&0x00FF0000)>>16);
		g = life*((c1&0x0000FF00)>>8);
		b = life*(c2&0x000000FF);
		
		r2 = r+((c2&0x00FF0000)>>16);
		g2 = g+((c2&0x0000FF00)>>8);
		b2 = b+(c2&0x000000FF);
		

		if(r2>255)
		  r2=255;
		if(g2>255)
		  g2=255;
		if(b2>255)
		  b2=255;
		
		buffer[offsetx+offset2] = MAKE_COLOR_CHAR(r2,g2,b2);
		offset++;
	      }
	    offsetx++;

	  }
    }
}




void putSpriteAdditiveZBuffer(int *buffer, sSprite *spritet, int px, int py, float z,float life)
{
  int x,y;
  int offsetx, startx;
  int offsety, starty;
  unsigned int r,g,b;
  unsigned int r2,g2,b2;
  int offset=0, offset2;
  unsigned int c1, c2;




  if((px>XSIZ) || (py>YSIZ))
    return;
 

  startx = px;
  if(startx<0)
    startx = -px;
  starty = py;
  if(starty<0)
    starty = -py;

  for(y=0;y<spritet->height;y++)
    {
      offsety = y+py;
      if(offsety>YSIZ)
	return;
      offset2 = offsety*XSIZ;


      if(offsety>0)
	for(x=0;x<spritet->width;x++)
	  {
	    offsetx = x+px;
	    if(offsetx>XSIZ)
	      break;
	    if(offsetx>0)
	      {
		if(z<scene->zbuffer[offsetx+offset2])
		  {
		    c1 = spritet->pixels[offset];
		    c2 = buffer[offsetx+offset2];

		    r = (int)(life*1.0f*((c1&0x00FF0000)>>16));
		    g = (int)(life*1.0f*((c1&0x0000FF00)>>8));
		    b = (int)(life*1.0f*(c1&0x000000FF));
		    
		    r2 = r+((c2&0x00FF0000)>>16);
		    g2 = g+((c2&0x0000FF00)>>8);
		    b2 = b+(c2&0x000000FF);
		    
		    
		    if(r2>255)
		      r2=255;
		    if(g2>255)
		      g2=255;
		    if(b2>255)
		      b2=255;
		    
		    buffer[offsetx+offset2] = MAKE_COLOR_CHAR(r2,g2,b2);   
		    scene->zbuffer[offsetx+offset2] = z;
		  }
	      }
	    offset++;
	  }
offset +=spritet->width;
    }
}









void putSquareSoustractive(unsigned int *s, int x, int y, int size, int r, int g, int b)
{
  int xe, ye;
  int i,j,jb=x*4,oi=y*XSIZ, oib=y*XSIZ*4;
  int tr, tg, tb;
  unsigned char *sb = (unsigned char*)s;



  if(x>XSIZ || y>YSIZ)
    return;
  xe = x+size;
  ye = y+size;
  if(xe>XSIZ)
    xe=XSIZ;
  if(ye>YSIZ)
    ye=YSIZ;

  for(i=y;i<ye;i++)
    {
      for(j=x;j<xe;j++)
	{
	  tr = sb[jb+oib] - r;
	  if(tr<0) tr=0;
	  tg = sb[jb+oib+1] - g;
	  if(tg<0) tg=0;
	  tb = sb[jb+oib+2] - b;
	  if(tb<0) tb=0;

	  s[j+oi] = MAKE_COLOR_CHAR(((unsigned char)tr),((unsigned char)tg),((unsigned char)tb));
	  

	  jb+=4;

	}
      oi+=XSIZ;
      oib+=(XSIZ*4);
    }
}





void putSprite(int *buffer, sSprite *spritet, int px, int py)
{
  int x=0,y=0;
  int offsetx, startx;
  int offsety, starty;
  
  if(px>XSIZ || py>YSIZ)
    return;

  startx = px;
  if(startx<0)
    startx = -px;
  starty = py;
  if(starty<0)
    starty = -py;



  for(y=starty;y<spritet->height;y++)
    {
      offsety = y+py;
      if(offsety>YSIZ)
	return;
     

      for(x=startx;x<spritet->width;x++)
	{
	  offsetx = x+px;
	  if(offsetx>XSIZ)
	    break;

	  buffer[offsetx+offsety*XSIZ] = spritet->pixels[x+y*(spritet->width)];
	}
    }
}

void putSpriteScaled(int *buffer, sSprite *spritet, int px, int py, float sx, float sy)
{
  int x,y;
 
  float xinc=1.0f/sx ,yinc=1.0f/sy;
  float spx=0, spy=0;

  if(px>XSIZ || py>YSIZ)
    return;


  for(y=0;y<spritet->height*sy;y++)
    {
      if(px+y > YSIZ)
	break;
      if(py+y > 0)
      for(x=0;x<spritet->width*sx;x++)
	{
	  if(x+px > XSIZ)
	    break;
	  if(x+px < 0)
	    break;
	  buffer[(px+x)+(y+py)*XSIZ] = spritet->pixels[((int)spx)+((int) (spy))*spritet->width];
	
	  //printf("%d %d\n", (px+x)+(y+py)*XSIZ, ((int)spx)+((int) (spy))*spritet->width);
	  
	  spx+=xinc;
	}
      spy+=yinc;
      spx=0;
    }
}




void putSpriteAlpha(int *buffer, sSprite *spritet, int px, int py)
{
  int x,y;
  int offsetx, startx;
  int offsety, starty;
  unsigned char r,g,b,a;
  unsigned char r2,g2,b2;
  float pct;



  if((px>XSIZ) || (py>YSIZ))
    return;
 

  startx = px;
  if(startx<0)
    startx = -px;
  starty = py;
  if(starty<0)
    starty = -py;


  for(y=0;y<spritet->height;y++)
    {
      offsety = y+py;
      if(offsety>YSIZ)
	return;
     
      if(offsety>0)
	for(x=0;x<spritet->width;x++)
	  {
	    offsetx = x+px;
	    if(offsetx>XSIZ)
	      break;
	    if(offsetx>0)
	      {
		r = ((spritet->pixels[x+y*(spritet->width)])&0x00FF0000)>>16;
		g = ((spritet->pixels[x+y*(spritet->width)])&0x0000FF00)>>8;
		b = ((spritet->pixels[x+y*(spritet->width)])&0x000000FF);
		a = ((spritet->pixels[x+y*(spritet->width)])&0xFF000000)>>24;
		
		r2 = ((buffer[offsetx+offsety*XSIZ])&0x00FF0000)>>16;
		g2 = ((buffer[offsetx+offsety*XSIZ])&0x0000FF00)>>8;
		b2 = ((buffer[offsetx+offsety*XSIZ])&0x000000FF);
		
		pct = a/255.0f;
		
		r = (r * pct) + (r2 * (1.0f-pct));
		g = (g * pct) + (g2 * (1.0f-pct));
		b = (b * pct) + (b2 * (1.0f-pct));
		
		
		buffer[offsetx+offsety*XSIZ] = MAKE_COLOR_CHAR(r,g,b);
	      }
	  }
    }
}

void putSpriteScaledAlpha(int *buffer, sSprite *spritet, int px, int py, float sx, float sy)
{
  int x,y; 
  float xinc=1.0f/sx ,yinc=1.0f/sy;
  float spx=0, spy=0;
  unsigned char r=0,g=0,b=0,a=0;
  unsigned char r2,g2,b2;
  float pct=0, pct2=0;
  int col, col2=0;


  if(px>XSIZ || py>YSIZ)
    return;


  for(y=0;y<spritet->height*sy;y++)
    {
      if(px+y > YSIZ)
	break;
      if(py+y > 0)
      for(x=0;x<spritet->width*sx;x++)
	{
	  if(x+px >= XSIZ)
	    break;
	  if(x+px < 0)
	    break;

	  col = (spritet->pixels[((int)spx)+((int) (spy))*spritet->width]);
	  
	  r = (col&0x00FF0000)>>16;
	  g = (col&0x0000FF00)>>8;
	  b = (col&0x000000FF);
	  a = (col&0xFF000000)>>24;
	  
	  col2 = (buffer[(px+x)+(y+py)*XSIZ]);

	  r2 = (col2&0x00FF0000)>>16;
	  g2 = (col2&0x0000FF00)>>8;
	  b2 = (col2&0x000000FF);
	  
	  pct = a/255.0f;
	  pct2 = 1.0f-pct;
	  r = (r * pct) + (r2 * (pct2));
	  g = (g * pct) + (g2 * (pct2));
	  b = (b * pct) + (b2 * (pct2));
	  
	 
	    buffer[(px+x)+(y+py)*XSIZ] = MAKE_COLOR_CHAR(r,g,b);

	  spx+=xinc;
	}
      spy+=yinc;
      spx=0;
    }
}


void putSpriteTransp(int *buffer, sSprite *spritet, int px, int py)
{
  int x,y;
  int offsetx, startx;
  int offsety, starty;
  unsigned char a;

  if(px>XSIZ || py>YSIZ)
    return;


  startx = px;
  if(startx<0)
    startx = -px;
  starty = py;
  if(starty<0)
    starty = -py;



  for(y=starty;y<spritet->height;y++)
    {
      offsety = y+py;
      if(offsety>YSIZ)
	return;
     

      for(x=startx;x<spritet->width;x++)
	{
	  offsetx = x+px;
	  if(offsetx>XSIZ)
	    break;

	    a = ((spritet->pixels[x+y*(spritet->width)])&0xFF000000)>>24;
	  
	    if(a != 0)
	      buffer[offsetx+offsety*XSIZ] = spritet->pixels[x+y*(spritet->width)];
	}
    }
}

void putSpriteScaledTransp(int *buffer, sSprite *spritet, int px, int py, float sx, float sy)
{
  int x,y;
 
  float xinc=1.0f/sx ,yinc=1.0f/sy;
  float spx=0, spy=0;
  unsigned char a;

  if(px>XSIZ || py>YSIZ)
    return;

  for(y=0;y<spritet->height*sy;y++)
    {
      if(px+y > YSIZ)
	break;
      if(py+y > 0)
      for(x=0;x<spritet->width*sx;x++)
	{
	  if(x+px >= XSIZ)
	    break;
	  if(x+px < 0)
	    break;


	  a = (spritet->pixels[((int)spx)+((int)(spy))*spritet->width]&0xFF000000)>>24;
	  if(a != 0)
	    buffer[(px+x)+(y+py)*XSIZ] = spritet->pixels[((int)spx)+((int) (spy))*spritet->width];
	  spx+=xinc;
	}
      spy+=yinc;
      spx=0;
    }
}
