/*
 *  Pee      Libcaca Demo Program
 *  Copyright (c) 2004, 2005 Jean-Yves Lamoureux <jylam@lnxscene.org>
 *                All Rights Reserved
 */

/** \file sprites.h
 *  \version \$Id: sprites.h 01/14/01 Jylam$
 *  \author Jean-Yves Lamoureux <jylam@lnxscene.org>
 *  \brief The \e sprites routines header
 *
 *  This header contains the public types and functions that needed
 *  to handle sprites
 */

#ifndef __SPRITES_H_
#define __SPRITES_H_



#define MAKE_COLOR_CHAR(r,g,b) ((0<<24) +((r)<<16) +((g)<<8) +(b))
#define MAKE_COLOR(color) (((color->r)<<16) +((color->g)<<8) +(color->b))

#define COLOR_R(c) (((c)&0xFF0000)>>16)
#define COLOR_G(c) (((c)&0x00FF00)>>8)
#define COLOR_B(c) ((c)&0xFF)


typedef struct _sSprite
{
  int width, height;
  unsigned int *pixels;
}sSprite;




void putSquare(unsigned int *s, int x, int y, int size, int r, int g, int b);
void putSquareAdditive(unsigned int *s, int x, int y, int size, int r, int g, int b);
void putSquareSoustractive(unsigned int *s, int x, int y, int size, int r, int g, int b);

void putSprite(int *buffer, sSprite *sprite, int px, int py);
void putSpriteAlpha(int *buffer, sSprite *spritet, int px, int py);
void putSpriteAdditive(int *buffer, sSprite *spritet, int px, int py, float life);
void putSpriteAdditiveZBuffer(int *buffer, sSprite *spritet, int px, int py, float z,float life);
void putSpriteScaled(int *buffer, sSprite *spritet, int px, int py, float sx, float sy);
void putSpriteTransp(int *buffer, sSprite *spritet, int px, int py);
void putSpriteScaledTransp(int *buffer, sSprite *spritet, int px, int py, float sx, float sy);
void putSpriteScaledAlpha(int *buffer, sSprite *spritet, int px, int py, float sx, float sy);
sSprite *loadPng(unsigned char *name);


#endif /* __SPRITES_H_ */
